/*
    Blacky Office Protocol

    Dieser Server bzw. Klient soll den Datenaustausch zwischen Server
    und Klient vereinfachen. Zum Beispiel das Abholen grerer mengen
    eMail oder Updaten der Homepage

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
//#include <varargs.h>
#include <stdarg.h>
#include <sys/socket.h>
#include <signal.h>

#include "hofmeier.h"


char blacky_ver_info[] = "Blacky Office Protocol v0.10 (c) Copyright 2000-2002 Andreas Hofmeier";
char COMPRESS[]   = "gzip -9";
char DECOMPRESS[] = "gzip -d";
char MD5SUM[]     = "md5sum";


main(argc, argv)
  int argc;
  char *argv[];
{
  int sock;                            // Socket zum Server
  char filename_trans[256];            // Vertige Datei zum Senden, Empfangende Datei
  char filename_skript[256];           // Datei, mit der das Script aufgerufen wird
  char command[256];                   // String, zum Temporrem Speichern von SH-Kommandos
  char md5sum[33];                     // BUFFER fr 16Bit Prfsumme (32Byte Hex-Code + 1 EOS{\0})
  char md5sum2[33];                    // -- || --; fr Prfsumme vom Parter
  FILE *f;                             // Datei, zum Auslesen der Prfsummen und berprfen ob Uploaddatei vorhanden ist
  int verbose = 0;                     // == 1: Zeige alle zusetzlichen Infos an
  char what[20];                       // TEMP-String, wirklich BOP?

  int sockets_in[2];
  int sockets_out[2];


  // HELP-Text anzeigen
  if (argc < 6 || argc > 7) {
    printf("bop <ServerName> <ServerPort> <LoginName> <PassWort> <Datei> [-v]\n");
    printf("   ServerName: Name oder IP, des Server auf den Sie zugreifen wollen\n");
    printf("   ServerPort: Port, auf dem das Serverprogramm bopd auf bem Server horcht\n");
    printf("               Meist 65140.\n");
    printf("   LoginName:  Name, mit dem Sie sich beim Server anmelden wollen\n");
    printf("   PassWort:   Das zu dem Name gehrige Passwort\n");
    printf("   Datei:      Datei in der eventuelle Uploads gespeichert sind,\n");
    printf("               und Download gespeichert werden\n");
    printf("   -v:         Zeige alle Informationen.\n");
    exit(1);
  }
  // Verbose?
  verbose = ((argc == 6) ? 0 : ( (argv[6][0] == '-') && (argv[6][1] == 'v')));
  // ########################### LOGIN #######################################
  // Mit Server Verbinden...
  if (verbose) {
    printf("Verbinde mit Server (%s:%s)...\n", argv[1], argv[2]);
  }
  if ((sock = Socket(argv[1], atoi(argv[2]))) < 0) {
    fprintf(stderr, "Konnte keine Verbindung zum Server (%s:%s) herstellen!\n", argv[1], argv[2]);
    exit(1);
  }
  // Wirklich BOP?
  SockRecvString(sock, what);
  if (strcmp(what, "bop0") == 0) {
    fprintf(stderr, "** WARNING: Using the old BOP-Protocol (BOP0)!\n");
    SockSendString(sock, argv[3]); // LoginName
    SockSendString(sock, argv[4]); // PassWort
  } else {
    // The normal Protocoll
    if (strcmp(what, "bop1") == 0) {
      SockSendString(sock, argv[3]); // LoginName
      SockMD5Auth(sock, argv[4]);    // Prfen ob Gegenseite die, fr die sie sich ausgiebt
    } else {
      fprintf(stderr, "** ERROR: Protocol not supported! (Port != 65140?)\n");
      exit(1);
    }
  }
  if (verbose) {
    printf("Logge mich ein auf Server (%s:%s) als %s...\n", argv[1], argv[2], argv[3]);
  }
  // Warte auf OK
  waitfor(NULL, sock, command /* ein Buffer */, "Login incorect!");
  // Filenames zuweisen
  sprintf(filename_trans, "/tmp/.bop.%d.trans", getpid());
  //  sprintf(filename_skript, "/tmp/.bop.%d", getpid());
  strcpy(filename_skript, argv[5]);

  // ############################# Kleinet > Server ############################
  // UpLoad
  if ((f = fopen(filename_skript, "r")) != NULL) {
    fclose(f);
    // Datei ist da
    // Prfsumme Erzeugen

    sprintf(command, "%s %s", MD5SUM, filename_skript);
    if (verbose) {
      printf("Errechne Prfsumme (%s)...\n", command);
    }
    // Erzeugen & Einlesen der Prfsumme
    if  ((f = popen(command, "r")) == NULL) {
      fprintf(stderr, "** ERROR: Es konnte keine Prfsumme errechnet Werden! (Womglich ist %s nicht vorhanden)\n", MD5SUM);
      remove(filename_trans);
      exit(1);
    }
    fscanf(f, "%s", md5sum);
    pclose(f);

    // Compress
    sprintf(command, "%s < %s > %s", COMPRESS, filename_skript, filename_trans);
    if (verbose) {
      printf("Compress Upload-File (%s)...\n", command);
    }
    system(command);
    // UpLoaden
    if ((f = fopen(filename_trans, "r")) == NULL) {
      // Fehler, Kein Upload
      fprintf(stderr, "** ERROR: Ferler beim ffnen der Compremieren Datei! (%s)\nMglicherweise is %s nicht vorhanden\n*** KEIN UPLOAD ***\n", filename_trans, COMPRESS);
    } else {
      fclose(f);
      // OK, Upload
      SockSendString(sock, "upload");
      SockSendFile(sock, filename_trans);
      // bertragen der Prfsumme
      SockSendString(sock, md5sum);
    }
    // Warte auf OK
    waitfor(NULL, sock, command /* ein Puffer */, "MD5Sum");
    // UPLOAD OK, Dateien Lschen
    remove(filename_trans);
    remove(filename_skript);
  }

  // ###################### Startte Skript auf Server ########################
  // Run
  if (verbose) {
    printf("Starte Script auf dem Server...\n");
  }
  SockSendString(sock, "run");
  // ####################### Server > Klient ################################
  // Hm, skripte koennen text ausgeben, deshalb abwarten bis \n.\n kommt
  waitforpoint(sock, command /* ein Puffer */);
  // Warte auf OK
  if (waitfor("download", sock, command /* ein Puffer */, "Script on Server") == 0) {
    // Kein Download
    fprintf(stderr, "Kein Download.\n");
    exit(0);
  } else {
    // Download
    SockRecvFile(sock, filename_trans);
    // Dekomrimieren
    sprintf(command, "%s < %s > %s", DECOMPRESS, filename_trans, filename_skript);
    if (verbose) {
      printf("Dekompremiere (%s)...\n", command);
    }
    system(command);
    // Prfsumme Erzeugen
    sprintf(command, "%s < %s", MD5SUM, filename_skript);
    if (verbose) {
      printf("Erzeuge Prfsumme (%s)...\n", command);
    }
    // Erzeugen & Einlesen der Prfsumme
    if ((f = popen(command, "r")) == NULL) {
      fprintf(stderr, "** ERROR: Es konnte keine Prfsumme errechnet Werden! (Womglich ist %s nicht vorhanden)\n", MD5SUM);
      remove(filename_trans);
      remove(filename_skript);
      exit(1);
    }
    fscanf(f, "%s", md5sum);
    fclose(f);
    // Lschen der Transferdatei
    remove(filename_trans);
    // Empfangen dre Prfsumme vom Server
    SockRecvString(sock, md5sum2);
    // Vergleichen
    if (strcmp(md5sum, md5sum2) == 0) {
      // OK
      SockSendString(sock, "OK");
      if (verbose) {
	printf("Beendet...\n", command);
      }
      remove(filename_trans);
      exit(0);
    } else {
      // ERROR
      fprintf(stderr, "** ERROR: Prfsumme des Downloads stimmt nicht!\n");
      remove(filename_trans);
      remove(filename_skript);
      exit(1);
    }
  }
}


waitfor(char *s, int sock, char *buf, char *meldung)
{
  if (SockRecvString(sock, buf) < 0) {
    fprintf(stderr, "** ERROR: Stream broken\n");
    exit(1);
  }
  if (strcmp(buf, "OK") == 0) {
    return 0;
  }
  if (s != NULL) {
    if (strcmp(s, buf) == 0) {
      return 1;
    }
  }
  fprintf(stderr, "SERVER> %s\n", buf);
  fprintf(stderr, "** ERROR: %s\n", meldung);  
  exit(1);
}


waitforpoint(int sock, char *buf)
{
  int i;

  while (1) {
    // Lese einer Zeilem bis \n
    for (i = 0; buf[(i == 0) ? i : i - 1] != '\n'; i++) {
      if (read(sock, buf + i, 1) != 1) {
	buf[i] = '\n';
      }
    }
    buf[i] = 0;
    // Wenn Zeile nur ``.'' enthlt OK
    if ((buf[0] == '.') && ((buf[1] == 0) || (buf[1] == '\n'))) {
      return 0;
    }
    // Wenn nicht Ausgeben, aber nur wenn String nicht leer
    if (buf[i - 1] == '\n') {
      buf[i - 1] = 0;
    }
    if (buf[0] != 0) {
      fprintf(stderr, "SERVER> %s\n", buf);
    }
  }
}
