/*
    Blacky Office Protocol

    Dieser Server bzw. Klient soll den Datenaustausch zwischen Server
    und Klient vereinfachen. Zum Beispiel das Abholen grerer mengen
    eMail oder Updaten der Homepage

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <varargs.h>
#include <sys/socket.h>
#include <signal.h>
#include <syslog.h>

#include "hofmeier.h"

#include <sys/types.h>
#include <sys/socket.h>




char blacky_ver_info[] = "Blacky Office Protocol v0.10 (c) Copyright 2000-2002 Andreas Hofmeier";
char COMPRESS[]   = "gzip -9";
char DECOMPRESS[] = "gzip -d";
char MD5SUM[]     = "md5sum";
char MAILDIR[]    = "/var/spool/mail";
char CONFIGFILE0[]   = "/blacky/vt/bop.conf";
char CONFIGFILE1[]   = "/blacky/bop.conf";
char CONFIGFILE2[]   = "/etc/bop.conf";
#define CONFIG_LINE_BUF_SIZE 256


/* Prft anhant der Config-Datei die Identitt des Users, und Ld
   infos (Schlssel etc.)*/
iflogin(name, pwd, cmd, errorcmd)
  char *name, *pwd, *cmd, *errorcmd;
{
  char cd[CONFIG_LINE_BUF_SIZE];
  int namelen = strlen(name);
  FILE *conf;

  // CONF-File ffnen
  if ((conf = fopen(CONFIGFILE0, "r")) == NULL) {
    if ((conf = fopen(CONFIGFILE1, "r")) == NULL) {
      if ((conf = fopen(CONFIGFILE2, "r")) == NULL) {
	syslog(LOG_INFO, "** ERROR: Can't open any configurationsfile!: %s,%s,%s\n", CONFIGFILE0, CONFIGFILE1, CONFIGFILE2);
	exit(1);
      }
    }
  }
  // LESEN
  for (  ;  ;  ) {
    /* Lesen einer Zeile (eines Datensatzes) */
    fgets(cd, CONFIG_LINE_BUF_SIZE, conf);
    
    /* Passt das LogIn name ? */
    if (strncmp(name, cd, namelen) == 0) {
      int pwdlen = strlen(pwd);
      /* Ist das Passwort OK? */
      if (strncmp(pwd, cd + namelen + 1, pwdlen) == 0) {
	/* Login OK */
	/* Auslesen der Daten */
	/* Rest der Zeile */
	int i = namelen + 1 + pwdlen + 1;
	char *info = cd + i;
	/* Command */
	//	      info += (i + 1);
	for (i = 0; (!((info[i] == '|') || (info[i] == 0))); i++) {
	  cmd[i] = info[i];
	}
	cmd[i] = 0;
	if (cmd[i - 1] == '\n') {
	  cmd[i - 1] = 0;
	}
	errorcmd[0] = 0;
	if (info[i] == '|') {
	  info += (i + 1);
	  /* Command, falls ein Fehler bei der bertragung aufgetreten ist */
	  for (i = 0; (!((info[i] == '|') || (info[i] == 0))); i++) {
	    errorcmd[i] = info[i];
	  }
	  errorcmd[i] = 0;
	  if (errorcmd[i - 1] == '\n') {
	    errorcmd[i - 1] = 0;
	  }
	}
	/* OK */
	fclose(conf);
	return 0;
      }
    }
    if (feof(conf) != 0) {
      fclose(conf);
      /* Dateiende erreicht, kein gltiger eintrag, EXIT */
      return 1;
    }
  }
}


main(argc, argv)
  int argc;
  char *argv[];
{
  int sock = fileno(stdin);            // Socket zum Klient
  struct sockaddr_in      cs;          // Communication parameters
  int       len = sizeof(cs);          // Informationen ber PEER
  char                   *ip;          // -- || --
  struct hostent   *ch_again;          // -- || --
  char name[CONFIG_LINE_BUF_SIZE];     // LOGIN-Name
  char pwd[CONFIG_LINE_BUF_SIZE];      // LOGIN-PassWort
  char cmd[CONFIG_LINE_BUF_SIZE];      // Commando / Skript welches gestartet werden soll
  char errorcmd[CONFIG_LINE_BUF_SIZE]; // Commando / Skript welches gestartet werden soll, wenn beim Transfer zum Klienten ein Fehler aufgetreten ist (Optional)
  char what[20];                       // TEMP-String zum Empfangen (gleich run oder erst upload{Klient>Server} )
  char filename_trans[256];            // Vertige Datei zum Senden, Empfangende Datei
  char filename_md5sum[256];           // MD5sum: Prfsumme
  char filename_skript[256];           // Datei, mit der das Script aufgerufen wird
  char command[256];                   // String, zum Temporrem Speichern von SH-Kommandos
  char md5sum[33];                     // BUFFER fr 16Bit Prfsumme (32Byte Hex-Code + 1 EOS{\0})
  char md5sum2[33];                    // -- || --; fr Prfsumme vom Parter
  FILE *f;                             // Datei, zum Auslesen der Prfsummen und berprfen ob Uploaddatei vorhanden ist

  // LOG-File ffnen (syslogd)
  openlog("bopd", LOG_CONS || LOG_NDELAY, LOG_AUTHPRIV);
  // Wer hat eine Verbindung aufgebaut
  if (getpeername(sock,(struct sockaddr *)&cs,&len) < 0){
    syslog(LOG_INFO, "connected: ** ERROR: Can't get socketdata: getpeername()");
  } else {
    ip = (char *) strdup(inet_ntoa(cs.sin_addr));
    ch_again = gethostbyname(ip);
    syslog(LOG_INFO, "connected: %s\n(%s)\n", ip, strdup(ch_again->h_name));
  }
  // Ident-String
  SockSendString(sock, "bop0");
  // ############################ LOGIN ###############################
  // Name und Paswort empfangen
  SockRecvString(sock, name);
  SockRecvString(sock, pwd);
  // Login berprfen
  if (iflogin(name, pwd, cmd, errorcmd) != 0) {
    SockSendString(sock, "Login incorect!"); // Falsch: EXIT
    syslog(LOG_INFO, "** ERROR: LogIn Failt!: %s:%s", name, pwd);
    exit(1);
  } else {
    syslog(LOG_INFO, "LogIn: %s", name);     // OK
    SockSendString(sock, "OK");
  }
  // ######################## Klient > Server ###########################
  // zuerst UpLoad oder gleich das Skript starten?
  SockRecvString(sock, what);
  // Filenames zuweisen
  sprintf(filename_trans, "/tmp/.bopd.%d.trans", getpid());
  sprintf(filename_md5sum, "/tmp/.bopd.%d.md5sum", getpid());
  sprintf(filename_skript, "/tmp/.bopd.%d", getpid());

  // Klient >> Server
  if (strcmp(what, "upload") == 0) {
    // Nach diesem Teil Run...
    what[0] = 0;
    // File empfangen
    if (SockRecvFile(sock, filename_trans) <= 0) {
      SockSendString(sock, "ERROR recieving the File");
      exit(1);
    }
    // Decompremieren
    sprintf(command, "cat %s | %s > %s", filename_trans, DECOMPRESS, filename_skript);
    system(command);
    // Prfsumme Erzeugen
    sprintf(command, "cat %s | %s > %s", filename_skript, MD5SUM, filename_md5sum);
    system(command);
    // Prfsume aus Datei Lesen
    f = fopen(filename_md5sum, "r");
    if (f == NULL) {
      SockSendString(sock, "ERROR: Es konnte keine Prfsumme errechnet Werden! (Womglich ist %s nicht vorhanden)");
      exit(1);
    }
    fscanf(f, "%s", md5sum);
    fclose(f);
    // Prfsumme vom Klienten Empfangen
    SockRecvString(sock, md5sum2);
    // Prfsummen Vergleichen
    if (strcmp(md5sum, md5sum2) == 0) {
      // OK
      SockSendString(sock, "OK");
    } else {
      // EROOR
      SockSendString(sock, "ERROR: Prfsumme des Downloads stimmt nicht!");
      exit(1);
    }
    // berflssige Dateien Lschen
    remove(filename_trans);
    remove(filename_md5sum);
  }

  // ############################## Start Skript ##############################
  if (what[0] == 0) {
    SockRecvString(sock, what);
  }
  if (strcmp(what, "run") == 0) {
    // eMail-Mode (internes Skript)
    if (strcasecmp(cmd, "eMail") == 0) {
      remove(filename_skript);
      // Hm, bei der letzten Sitzung sind eMails nicht abgeholt worden, programm wurde gekillt
      sprintf(command, "cat %s/.%s >> %s/%s 2> /dev/null", MAILDIR, name, MAILDIR, name);
      system(command);
      // eMail-Datei umbenenne, damit es keine Konflikte mit POP. sendmail, etc. gibt
      sprintf(command, "mv %s/%s %s/.%s > /dev/null 2> /dev/null", MAILDIR, name, MAILDIR, name);
      system(command);
      // Prfsumme Erzeugen
      sprintf(command, "cat %s/.%s | %s > %s", MAILDIR, name, MD5SUM, filename_md5sum);
      system(command);
      // Kompremieren
      sprintf(command, "cat %s/.%s | %s > %s", MAILDIR, name, COMPRESS, filename_trans);
      system(command);
    } else {
      // Normaler Modus, Skript Starten
      sprintf(command, "%s %s 2> /dev/null > /dev/null", cmd, filename_skript);
      syslog(LOG_INFO, "running %s\n", command);
      system(command);
      // Prfsumme Erzeugen
      sprintf(command, "cat %s | %s > %s 2> /dev/null", filename_skript, MD5SUM, filename_md5sum);
      system(command);
      // Kompremieren (Nur wenn Datei da ist, da sonst gzip Daten erzeugt)
      sprintf(command, "if [ -e %s ]; then cat %s | %s > %s 2> /dev/null; fi", filename_skript, filename_skript, COMPRESS, filename_trans);
      system(command);
    }
    // Alles OK
    fflush(stdout);
    write(sock, "\n.\n", 3);
  }

  // ######################### SERVER > Klient ####################################
  fflush(stdout);
  // Wenn Datei vorhanden ist zum Klienten bertragen
  if ((f = fopen(filename_trans, "r")) == NULL) {
    // Nicht Vorhanden, Exit
    SockSendString(sock, "OK");
    exit(0);
  } else {
    // Vorhanden, betragen
    fclose(f);
    // bertragen
    SockSendString(sock, "download");
    SockSendFile(sock, filename_trans);
    // Prfsummer Einlesen
    if ((f = fopen(filename_md5sum, "r")) == NULL) {
      // Keine Prfsumme, ERROR
      SockSendString(sock, "ERROR: Es konnte keine Prfsumme errechnet Werden!");
      if (strcasecmp(cmd, "eMail") == 0) { // eMail-Mode
	sprintf(command, "cat %s/.%s >> %s/%s 2> /dev/null", MAILDIR, name, MAILDIR, name);
	system(command);
	sprintf(command, "%s/.%s", MAILDIR, name);
	remove(command);
      } else {
	// Normaler Modus, wenn ERROR-Skript vorhanden , starten
	if (errorcmd[0] != 0) {
	  sprintf(command, "%s %s 2> /dev/null > /dev/null", errorcmd, filename_skript);
	}
	syslog(LOG_INFO, "running ErrorSkript: %s\n", command);
	system(command);
	remove(filename_trans);
	remove(filename_md5sum);
	remove(filename_skript);
      }
      exit(1);
    }
    // Einlesen der Prfsumme
    fscanf(f, "%s", md5sum);
    fclose(f);
    // Prfsummendatei Lschen
    remove(filename_md5sum);
    remove(filename_trans);
    // Prfsumme zum Klienten bertreagen
    SockSendString(sock, md5sum);
    // Warte auf OK
    SockRecvString(sock, what);
    if (strcmp(what, "OK") != 0) {
      // Fehler beim bertragen der Datei (Prfsumme bei Klienten Falsch)
      //	  fprintf(stderr, "** ERROR: UpLoad Incorect.\n");
      if (strcasecmp(cmd, "eMail") == 0) { // eMail-Mode
	sprintf(command, "cat %s/.%s >> %s/%s 2> /dev/null", MAILDIR, name, MAILDIR, name);
	system(command);
	sprintf(command, "chown %s %s/%s 2> /dev/null", name, MAILDIR, name);
	system(command);
	sprintf(command, "chmod u=rw,g=,o= %s/%s 2> /dev/null", name, MAILDIR, name);
	system(command);
	sprintf(command, "%s/.%s", MAILDIR, name);
	remove(command);
	remove(filename_trans);
	remove(filename_md5sum);
      } else {
	// Normaler Modus, wenn ERROR-Skript vorhanden , starten
	if (errorcmd[0] != 0) {
	  sprintf(command, "%s %s 2> /dev/null > /dev/null", errorcmd, filename_skript);
	}
	syslog(LOG_INFO, "running ErrorSkript: %s\n", command);
	system(command);
	remove(filename_trans);
	remove(filename_md5sum);
	remove(filename_skript);
      }
      exit(1);
    }
    // Alles OK
    if (strcasecmp(cmd, "eMail") == 0) { // eMail-Mode (eMail-Datei Lschen)
      sprintf(command, "%s/.%s", MAILDIR, name);
      remove(command);
    }
    // Normaler Modus oder eMail, alle TEMP-Dateien Lschen
    remove(filename_trans);
    remove(filename_md5sum);
    remove(filename_skript);
    exit(0);
  }
}
